刷题198. House Robber

一、题目说明

题目198. House Robber,给一列正整数表示每个房间存的金币,不能连续抢2个房间,计算可以得到的最大金币。

二、我的解答

这个题目,我列举了n=1,2,3,...5的情况,没有找到规律。后面看了解答知道了:

dp[i+1]= max(dp[i-2]+nums[i],dp[i-1])

代码如下:

class Solution{
	public:
		int dfs(vector<int>& nums,int n){
			if(n==0) return 0;
			if(n==1) return nums[0];
			return max(dfs(nums,n-2)+nums[n-1],dfs(nums,n-1));
		}
		int rob(vector<int>& nums){
			return dfs(nums,nums.size());
		}
};

遗憾的是,超时:Time Limit Exceeded,通过map,裁剪如下:

class Solution{
	public:
		int dfs(vector<int>& nums,int n){
			if(n==0) return 0;
			if(n==1) return nums[0];
			if(ump.count(n)>0){
				return ump[n];
			}
			int result = max(dfs(nums,n-2)+nums[n-1],dfs(nums,n-1));
			ump[n] = result;
			return result;
		}
		int rob(vector<int>& nums){

			return dfs(nums,nums.size());
		}
	private:
		unordered_map<int,int> ump;
};
Runtime: 4 ms, faster than 58.41% of C++ online submissions for House Robber.
Memory Usage: 9.2 MB, less than 5.66% of C++ online submissions for House Robber.

三、优化措施

用dp方法,代码如下:

class Solution{
	public:
		int rob(vector<int>& nums){
			//dp[i]表示抢第i所房子的最大值,
			//dp[i+1]= max(dp[i-2]+nums[i],dp[i-1] )
			if(nums.size()<1) return 0;
            if(nums.size() == 1) return nums[0];
			if(nums.size() == 2) return max(nums[0],nums[1]);

			vector<int> dp(nums.size()+1,0);
			dp[0] = nums[0];
			dp[1] = max(nums[0],nums[1]);

			for(int i=2;i<nums.size();i++){
				dp[i] = max(dp[i-2]+nums[i],dp[i-1]);
			}
			return dp[nums.size()-1];
		}
};

性能如下:

Runtime: 0 ms, faster than 100.00% of C++ online submissions for House Robber.
Memory Usage: 8.6 MB, less than 77.36% of C++ online submissions for House Robber.

原文地址:https://www.cnblogs.com/siweihz/p/12283574.html

时间: 2024-11-12 18:59:55

刷题198. House Robber的相关文章

用js刷题的一些坑

leecode可以用js刷题了,我大js越来越被认可了是吧.但是刷题中会因为忽略js的一些特性掉入坑里.我这里总结一下我掉过的坑. 坑1:js中数组对象是引用对象 js中除了object还有数组对象也是引用对象,这点常常被忽视,所以在递归的时候传递数组要用arr.slice(0)这样复制一个一样的新数组,不然会出现你传入的数组会被同级的递归改变,结果就不对了. 所以只要数组复制的地方最好都要这么写,除非你真的想引用.而且注意是slice不是splice这两个方法差别很大,你如果用splice(0

LeetCode刷题之一:寻找只出现一次的数字

投简历的时候看到了个刷题网站,http://www.nowcoder.com/527604,就做了一套题,现记录下来. 题目为: Given an array of integers, every element appears twice except for one. Find that single one. Note: Your algorithm should have a linear runtime complexity. Could you implement it withou

【leetcode刷题笔记】Sum Root to Leaf Numbers

Given a binary tree containing digits from 0-9 only, each root-to-leaf path could represent a number. An example is the root-to-leaf path 1->2->3 which represents the number 123. Find the total sum of all root-to-leaf numbers. For example, 1 / 2 3 T

BZOJ第一页刷题计划

BZOJ第一页刷题计划 已完成:1 / 100 BZOJ1000:A+B

刷题记录

刷题啦,刷题啦,咱也刷算法题. 先从牛客网的JS方面刷起,接着刷数据结构和算法,然后去刷leetcode,这儿记载自己从出错的地方. 1.题目描述 移除数组 arr 中的所有值与 item 相等的元素,直接在给定的 arr 数组上进行操作,并将结果返回 . 没有认真思考,写下了如下的答案 function removeWithoutCopy(arr, item) { for(i = 0; i < arr.length; i++) { if( arr[i] === item) { arr.spli

停课刷题总结-给自己一点鼓励吧

嗯,我已经停了四五天课在家刷BZOJ准备复赛了,感觉压力好大.但是,实际上感觉效率并不高,每天就是7-8题的样子,而且并不是每题都有质量.而且这几天刷下来,我貌似因为刷了太多水题的关系,打字写题的速度变慢了,有一点悠闲没有紧迫感了,要赶快把这个习惯给改掉!今天去学校做题被虐了,竟然一个简单的Hash没有调对[虽然我现在还是不知道为什么会死循环QAQ.]感觉吧,可能因为刷题有点不在状态了.[其实也因为刷题的间隙玩了几盘LOL,游戏这东西QAQ]被虐了,感觉很不爽,有点难受,毕竟我付出了那么多努力,

leetcode 刷题之路 63 Binary Tree Zigzag Level Order Traversal

Given a binary tree, return the zigzag level order traversal of its nodes' values. (ie, from left to right, then right to left for the next level and alternate between). For example: Given binary tree {3,9,20,#,#,15,7}, 3 / 9 20 / 15 7 return its zig

leetcode 刷题之路 64 Construct Binary Tree from Inorder and Postorder Traversal

Given inorder and postorder traversal of a tree, construct the binary tree. Note: You may assume that duplicates do not exist in the tree. 给出二叉树的中序遍历和后序遍历结果,恢复出二叉树. 后序遍历序列的最后一个元素值是二叉树的根节点的值,查找该元素在中序遍历序列中的位置mid,根据中序遍历和后序遍历性质,有: 位置mid以前的序列部分为二叉树根节点左子树中

半个暑假的刷题有感

这半个多月一来,主要是在刷DP.开始是一些简单的DP(可是我没有感觉有多简单=_=!!),然后是最大连续子序列,最大公共子序列,最大子矩阵等等,这些题目还好,有的题目甚至可以模板化. 还有一些没有解决的难题: 1024 Max Sum Plus Plus 最大m段不重叠子段和](可不连续)1244 Max Sum Plus Plus Plus [最大m段不重叠子段和](连续) 1074 Doing Homework [压缩dp](这个题整个程序都在用位运算,让我这个小白情何以堪啊) 还有记忆化搜